{

raVen's asciiz processing
(c) 2000 by raVen
(c) portions by turbo power software

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rAsciiz;
interface
Uses Objects;
{}
type
 CharSet = Set of Char;
{}
const
 AscMaxLen = $FFFF;
 AscNotFound = $FFFF;
{}
 function  Search(var Buffer; BufLength: Word; var Match; MatLength: Word): Word;
 procedure StrFree(var p: pChar);
 function  PasStr(const s: String): pChar;
 function  StrPas(const p: pChar): String;
 procedure StreamReadLnAsc(var Stream: tStream; var p: pChar);
 procedure StreamWriteLnAsc(var Stream: tStream; const p: pChar; EOL: String);
 function  PosStr(s: String; const p: pChar): Word;
 function  PosStrFrom(s: String; const p: pChar; FromPos: Word): Word;
 procedure DeleteAsc(var p: pChar; Start,Len: Word);
 function  CopyAsc(const p: pChar; Start,Len: Word): pChar;
 procedure InsertStr(s: String; var p: pChar; Start: Word);
 procedure AscReverse(var s: pChar);
 procedure AscUpcase(var A, B : pChar);
 procedure AscLocase(var A, B : pChar);
{}
implementation
Uses Strings;
{}
const
 zr          : Char = #00;
 cr          : Char = #13;
 lf          : Char = #10;
 stdEOL      : Set of Char = [#13,#10];
{}
function Search(var Buffer; BufLength: Word; var Match; MatLength: Word): Word; assembler;
{&USES ebx,esi,edi}
 asm
{$IfDef VirtualPascal}
  cld
  mov     edi,Buffer
  mov     ebx,edi
  mov     ecx,BufLength
  mov     edx,MatLength
  or      edx,edx
  je      @Error

  mov     esi,Match
  lodsb
  dec     edx
  sub     ecx,edx
  jbe     @Error

 @Next:
  repne   scasb
  jne     @Error
  or      edx,edx
  je      @Found

  push    ecx
  push    edi
  push    esi
  mov     ecx,edx
  repe    cmpsb
  pop     esi
  pop     edi
  pop     ecx
  jne     @Next

 @Found:
  dec     edi
  mov     eax,edi
  sub     eax,ebx
  jmp     @Done

 @Error:
  mov      eax,AscNotFound

 @Done:
{$EndIf}
{$IfDef Ver70}
  push    bp
  push    ds
  push    si

  cld
  les     di,Buffer
  mov     bx,di
  mov     cx,BufLength
  mov     dx,MatLength
  test    dx,dx
  jz      @Error

  lds     si,Match
  lodsb
  dec     dx
  sub     cx,dx
  jbe     @Error

 @Next:
  repne   scasb
  jne     @Error
  test    dx,dx
  jz      @Found

  push    cx
  push    di
  push    si
  mov     cx,dx
  repe    cmpsb
  pop     si
  pop     di
  pop     cx
  jne     @Next

 @Found:
  dec     di
  mov     ax,di
  sub     ax,bx
  jmp     @Done

 @Error:
  mov      ax,AscNotFound

 @Done:
  pop     si
  pop     ds
  pop     bp
{$EndIf}
 end;
{}
procedure StrFree(var p: pChar);
 begin
  if (p<>nil) then StrDispose(p);
  p:=nil;
 end;
{}
function PasStr(const s: String): pChar;
 var
  p: pChar;
 begin
  if Length(s)<>0 then
   begin
    GetMem(p,Length(s)+1);
    Move(s[1],p[0],Length(s));
    p[Length(s)]:=#0;
   end
  else p:=nil;

  PasStr:=p;
 end;
{}
function StrPas(const p: pChar): String;
 var
  l: Longint;
{$IfDef Ver70}
  Result: String;
{$EndIf}
 begin
  result:='';
  if p<>nil then l:=StrLen(p) else l:=0;
  if l>0 then
   begin
{$IfDef Ver70}
    Result[0]:=Char(l);
{$EndIf}
{$IfDef VirtualPascal}
    SetLength(Result,l);
{$EndIf}
    Move(p[0],Result[1],l);
   end;
{$IfDef Ver70}
  StrPas:=Result;
{$EndIf}
 end;
{}
procedure StreamReadLnAsc(var Stream: tStream; var p: pChar);
 var
  c,c1: Char;
  x: Word;
  np: pChar;
 begin
  if @Stream=nil then Exit;
  StrFree(p);
  GetMem(np,AscMaxLen);
  np[0]:=zr;
  x:=0;
  repeat
   Stream.Read(c,1);
   if (Stream.Status=stOK) and (not (c in stdEOL)) then np[x]:=c;
   Inc(x);
  until ((Stream.Status<>stOK) or (c in stdEOL) or (x>AscMaxLen));
  np[x-1]:=zr;
  if Stream.Status=stOK then
   begin
    Stream.Read(c1,1);
    if ((c=lf) and (c1<>cr)) or ((c=cr) and (c1<>lf)) then Stream.Seek(Stream.GetPos-1);
   end;
  if Stream.Status<>0 then
   begin
    Stream.Reset;
    Stream.Seek(Stream.GetSize);
   end;
  p:=StrNew(np);
  FreeMem(np,AscMaxLen);
 end;
{}
procedure StreamWriteLnAsc(var Stream: tStream; const p: pChar; EOL: String);
 var
  l: Word;
 begin
  if @Stream=nil then Exit;
  if p<>nil then l:=StrLen(p) else l:=0;
  if l>0 then Stream.Write(p[0],l);
  if eol<>'' then Stream.Write(EOL[1],Length(EOL));
 end;
{}
function  PosStr(s: String; const p: pChar): Word;
 var
  l: Word;
 begin
  PosStr:=AscNotFound;
  if (p=nil) then exit;
  l:=StrLen(p);
  if (l=0) then exit;
  PosStr:=Search(p[0],l,s[1],Length(s));
 end;
{}
function  PosStrFrom(s: String; const p: pChar; FromPos: Word): Word;
 var
  l,r: Word;
 begin
  PosStrFrom:=AscNotFound;
  if (FromPos<0) or (FromPos=AscNotFound) then FromPos:=0;
  if (p=nil) then exit;
  l:=StrLen(p);
  if (l=0) or (FromPos>l-1) then exit;
  r:=Search(p[FromPos],l-FromPos,s[1],Length(s));
  if (r<>AscNotFound) then PosStrFrom:=r+FromPos;
 end;
{}
procedure DeleteAsc(var p: pChar; Start,Len: Word);
 var
  aLen: Word;
  mid: Word;
  p1: pChar;
 begin
  if p=nil then exit;
  aLen:=StrLen(p);
  if Start<aLen then
   begin
    mid:=Start+Len;
    if mid<aLen then
     begin
      Move(p[mid],p[Start],aLen-mid);
      p[aLen-Len]:=zr;
     end
    else p[Start]:=zr;
   end
  else exit;
  p1:=StrNew(p);
  FreeMem(p,aLen+1);
  p:=p1;
  if p<>nil then if StrLen(p)=0 then StrFree(p);
 end;
{}
function  CopyAsc(const p: pChar; Start,Len: Word): pChar;
 var
  aLen: Word;
  r: pChar;
 begin
  if p=nil then exit;
  aLen:=StrLen(p);
  if Start>aLen then r:=nil
  else
   begin
    if Longint(Start)+Len>aLen then Len:=aLen-Start;
    GetMem(r,Len+1);
    Move(p[Start],r[0],Len);
    r[Len]:=zr;
   end;
  CopyAsc:=r;
 end;
{}
procedure InsertStr(s: String; var p: pChar; Start: Word);
 var
  aLen, oLen, mid: Word;
  p1: pChar;
 begin
  if p<>nil then aLen:=StrLen(p) else aLen:=0;
  oLen:=Length(s);
  GetMem(p1,oLen+aLen+1);
  if aLen<>0 then Move(p[0],p1[0],aLen+1);
  StrFree(p);
  if Start>aLen then Start:=aLen
  else
   begin
    mid:=Start+oLen;
    if mid<AscMaxLen then if aLen+oLen<AscMaxLen then Move(p1[Start], p1[mid], aLen-Start)
    else Move(p1[Start], p1[mid], AscMaxLen-mid);
   end;
  if Start+oLen>=AscMaxLen then oLen:=AscMaxLen-Start;
  Move(s[1], p1[Start], oLen);
  if aLen+oLen<AscMaxLen then p1[aLen+oLen]:=zr
  else p1[AscMaxLen]:=zr;
  StrFree(p);
  p:=p1;
 end;
{}
procedure AscReverse(var s: pChar);
 var
  x: LongInt;
  rev: pChar;
  l: Integer;
 begin
  l:=StrLen(s);
  GetMem(rev,l+1);
  for x:=0 to l-1 do
   begin
    rev[l-x-1]:=s[x];
   end;
  rev[l]:=zr;
  StrFree(s);
  s:=rev;
 end;
{}
function UpCase(C: Char): Char;
 begin
  case c of
   'a'..'z': c:=chr(ord(c)-(97-65));
   ''..'': c:=chr(ord(c)-(160-128));
   ''..'': c:=chr(ord(c)-(224-144));
   '': c:='';
  end;
  UpCase:=c;
 end;
procedure AscUpCase(var A, B : pChar);
 var
  x: Integer;
 begin
  if a=nil then exit;
  StrFree(b);
  GetMem(b,StrLen(a)+1);
  x:=0;
  while a[x]<>zr do
   begin
    b[x]:=UpCase(a[x]);
    Inc(x);
   end;
  b[x]:=zr;
 end;
{}
function LoCase(c: Char): Char;
 begin
  case c of
   'A'..'Z': c:=chr(ord(c)+(97-65));
   ''..'': c:=chr(ord(c)+(160-128));
   ''..'': c:=chr(ord(c)+(224-144));
   '': c:='';
  end;
  LoCase:=c;
 end;
procedure AscLoCase(var A, B : pChar);
 var
  x: Integer;
 begin
  if a=nil then exit;
  StrFree(b);
  GetMem(b,StrLen(a)+1);
  x:=0;
  while a[x]<>zr do
   begin
    b[x]:=LoCase(a[x]);
    Inc(x);
   end;
  b[x]:=zr;
 end;
{}
end.
